<?php

namespace Teknisa\CTB\Modules\Saldos\Factories;

use Doctrine\ORM\EntityManager;
    
abstract class RecalculoSaldosFactory{
    
    protected $entitymanager;
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    abstract public function callSaldoGeralProcedure($cdempresa, $datainic);
    
    public function getEmpresaFromPeriodoContabil($cdempresa, $dtsaldo, $nrorg) {
		$params = array();
		$params['P_CDEMPRESA'] = $cdempresa;
		$params['P_DTSALDO'] = $dtsaldo;
		$params['P_NRORG'] = $nrorg;
		$sql = "SELECT CDEMPRESA FROM CONTOPECTBL WHERE (CDEMPRESA = :P_CDEMPRESA) AND (TO_DATE(:P_DTSALDO, 'MM/YYYY') BETWEEN DTINICCONT AND DTFINACONT) AND NRORG = :P_NRORG";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
	}
	
}